VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Repeating Button Example"
   ClientHeight    =   990
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5055
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   990
   ScaleWidth      =   5055
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   3480
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   360
      Width           =   1455
   End
   Begin VB.Timer Timer1 
      Left            =   660
      Top             =   780
   End
   Begin VB.CommandButton Command1 
      Caption         =   "6"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   11.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Index           =   1
      Left            =   2820
      TabIndex        =   5
      Top             =   360
      Width           =   315
   End
   Begin VB.CommandButton Command1 
      Caption         =   "5"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   11.25
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Index           =   0
      Left            =   2460
      TabIndex        =   4
      Top             =   360
      Width           =   315
   End
   Begin VB.TextBox Text1 
      Alignment       =   1  'Right Justify
      Height          =   315
      Left            =   240
      Locked          =   -1  'True
      TabIndex        =   3
      Text            =   "Text1"
      Top             =   360
      Width           =   2115
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Update Interval:"
      Height          =   195
      Index           =   1
      Left            =   3480
      TabIndex        =   0
      Top             =   120
      Width           =   1140
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Press and hold buttons to change value:"
      Height          =   195
      Index           =   0
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   2865
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *********************************************************************
'  Copyright 2000 Karl E. Peterson, All Rights Reserved
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

Private ActiveButton As CommandButton

Private Sub Combo1_Click()
   ' Adjust timer delay for repeats.
   Timer1.Interval = Combo1.ItemData(Combo1.ListIndex)
End Sub

Private Sub Command1_Click(Index As Integer)
   ' Click fires following MouseUp.
   ' If the next statement is uncommented,
   ' you may have an unwanted call to the
   ' action routine.
   'Call ButtonAction(Index)
End Sub

Private Sub Command1_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   ' Set reference to pressed button. This
   ' needs to be something that can be
   ' understood in the Timer event. Control
   ' should be identifiable by Index, Tag,
   ' or some other unique property.
   Set ActiveButton = Command1(Index)
   Timer1.Enabled = True
   ' Fire first action event immediately,
   ' rather than wait for timer.
   Call ButtonAction(ActiveButton.Index)
End Sub

Private Sub Command1_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
   ' Clear reference to pressed button.
   ' This acts as signal in Timer event
   ' to stop repeating action and disable
   ' timer.
   Set ActiveButton = Nothing
End Sub

Private Sub Form_Load()
   Dim i As Long
   ' Setup controls
   Timer1.Enabled = False
   Timer1.Interval = 200  ' 5/sec
   Text1.Text = 0
   Set Me.Icon = Nothing
   ' Build interval list
   Combo1.AddItem "1000 ms"
   Combo1.ItemData(Combo1.NewIndex) = 1000
   Combo1.AddItem "500 ms"
   Combo1.ItemData(Combo1.NewIndex) = 500
   Combo1.AddItem "200 ms"
   Combo1.ItemData(Combo1.NewIndex) = 200
   Combo1.AddItem "100 ms"
   Combo1.ItemData(Combo1.NewIndex) = 100
   Combo1.AddItem "50 ms"
   Combo1.ItemData(Combo1.NewIndex) = 50
   Combo1.AddItem "10 ms"
   Combo1.ItemData(Combo1.NewIndex) = 10
   Combo1.ListIndex = 2
End Sub

Private Sub ButtonAction(Index As Integer)
   ' Standalone action routine called
   ' by Timer and/or Click events.
   If Index = 0 Then
      Text1.Text = Val(Text1.Text) + 1
   Else
      Text1.Text = Val(Text1.Text) - 1
   End If
End Sub

Private Sub Timer1_Timer()
   ' Repeat action as long as user has
   ' button depressed. When mouse is
   ' released, reference to pressed
   ' button will be cleared, and that's
   ' the signal to disable timer.
   If Not (ActiveButton Is Nothing) Then
      Call ButtonAction(ActiveButton.Index)
   Else
      Timer1.Enabled = False
   End If
End Sub
